<?php

declare(strict_types=1);

namespace App\Entity\Booking;

use ApiPlatform\Metadata\ApiResource;
use App\Entity\Access\Access;
use App\Entity\Billing\BillLine;
use App\Entity\Billing\EducationalProjectIntangible;
use App\Entity\Billing\EducationalProjectPayer;
use App\Entity\Core\File;
use App\Entity\Organization\Organization;
use App\Entity\Place\Place;
use App\Entity\Place\Room;
// use DH\Auditor\Provider\Doctrine\Auditing\Annotation\Auditable;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @todo : A la suite de la migration, il faut supprimer le nom de la table pour avoir une table EducationalProject, et supprimer l'attribut discr.
 * @todo : migration table tag_booking
 * Prestation pédagogique
 */
#[ApiResource(operations: [])]
// #[Auditable]
#[ORM\Entity]
class EducationalProject extends AbstractBooking
{
    /** @var Collection<int, EducationalProjectRecur> */
    #[ORM\OneToMany(targetEntity: EducationalProjectRecur::class, mappedBy: 'event', cascade: ['persist', 'remove'])]
    protected Collection $eventRecur;

    /** @var Collection<int, EducationalProject> */
    #[ORM\OneToMany(targetEntity: EducationalProject::class, mappedBy: 'parent')]
    protected Collection $timeline;

    #[ORM\ManyToOne(targetEntity: EducationalProject::class, cascade: ['persist'], inversedBy: 'timeline')]
    #[ORM\JoinColumn(nullable: true)]
    protected ?EducationalProject $parent = null;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(nullable: false)]
    protected Organization $organization;

    #[ORM\ManyToOne(inversedBy: 'silentPartners')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected ?Access $silentPartner = null;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected ?EducationalProjectPublic $public = null;

    #[ORM\ManyToOne(inversedBy: 'operationalPartners')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected ?Access $operationalPartner = null;

    /** @var Collection<int, Access> */
    #[ORM\ManyToMany(targetEntity: Access::class)]
    #[ORM\JoinTable(name: 'educationalproject_financier')]
    protected Collection $financiers;

    /** @var Collection<int, File> */
    #[ORM\ManyToMany(targetEntity: File::class)]
    protected Collection $files;

    /** @var Collection<int, EducationalProjectIntangible> */
    #[ORM\OneToMany(targetEntity: EducationalProjectIntangible::class, mappedBy: 'educationalProject', cascade: ['persist'], orphanRemoval: true)]
    protected Collection $educationalProjectIntangibles;

    /** @var Collection<int, EducationalProjectPayer> */
    #[ORM\OneToMany(targetEntity: EducationalProjectPayer::class, mappedBy: 'educationalProjectReceiver', cascade: ['persist'], orphanRemoval: true)]
    protected Collection $billingReceivers;

    /** @var Collection<int, BillLine> */
    #[ORM\OneToMany(targetEntity: BillLine::class, mappedBy: 'educationalProject', orphanRemoval: true)]
    protected Collection $billLines;

    /** @var Collection<int, AttendanceBooking> */
    #[ORM\OneToMany(targetEntity: AttendanceBooking::class, mappedBy: 'educationalProject', cascade: ['persist', 'remove'])]
    protected Collection $attendanceBooking;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected ?Place $place = null;

    #[ORM\ManyToOne(inversedBy: 'educationalProjects')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected ?Room $room = null;

    #[ORM\OneToOne(targetEntity: EducationalProjectAge::class, cascade: ['persist'])]
    protected ?EducationalProjectAge $ageDistribution;

    public function __construct()
    {
        $this->eventRecur = new ArrayCollection();
        $this->timeline = new ArrayCollection();
        $this->financiers = new ArrayCollection();
        $this->files = new ArrayCollection();
        $this->educationalProjectIntangibles = new ArrayCollection();
        $this->billingReceivers = new ArrayCollection();
        $this->billLines = new ArrayCollection();
        $this->attendanceBooking = new ArrayCollection();
        $this->organizer = new ArrayCollection();
        $this->equipments = new ArrayCollection();
        parent::__construct();
    }

    /**
     * @return Collection<int, EducationalProjectRecur>
     */
    public function getEventRecur(): Collection
    {
        return $this->eventRecur;
    }

    public function addEventRecur(EducationalProjectRecur $eventRecur): self
    {
        if (!$this->eventRecur->contains($eventRecur)) {
            $this->eventRecur[] = $eventRecur;
            $eventRecur->setEvent($this);
        }

        return $this;
    }

    public function removeEventRecur(EducationalProjectRecur $eventRecur): self
    {
        if ($this->eventRecur->removeElement($eventRecur)) {
            // set the owning side to null (unless already changed)
            if ($eventRecur->getEvent() === $this) {
                $eventRecur->setEvent(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, EducationalProject>
     */
    public function getTimeline(): Collection
    {
        return $this->timeline;
    }

    public function addTimeline(EducationalProject $timeline): self
    {
        if (!$this->timeline->contains($timeline)) {
            $this->timeline[] = $timeline;
            $timeline->setParent($this);
        }

        return $this;
    }

    public function removeTimeline(EducationalProject $timeline): self
    {
        if ($this->timeline->removeElement($timeline)) {
            // set the owning side to null (unless already changed)
            if ($timeline->getParent() === $this) {
                $timeline->setParent(null);
            }
        }

        return $this;
    }

    public function getParent(): ?self
    {
        return $this->parent;
    }

    public function setParent(?self $parent): self
    {
        $this->parent = $parent;

        return $this;
    }

    public function getOrganization(): ?Organization
    {
        return $this->organization;
    }

    public function setOrganization(?Organization $organization): self
    {
        $this->organization = $organization;

        return $this;
    }

    public function getSilentPartner(): ?Access
    {
        return $this->silentPartner;
    }

    public function setSilentPartner(?Access $silentPartner): self
    {
        $this->silentPartner = $silentPartner;

        return $this;
    }

    public function getPublic(): ?EducationalProjectPublic
    {
        return $this->public;
    }

    public function setPublic(?EducationalProjectPublic $public): self
    {
        $this->public = $public;

        return $this;
    }

    public function getOperationalPartner(): ?Access
    {
        return $this->operationalPartner;
    }

    public function setOperationalPartner(?Access $operationalPartner): self
    {
        $this->operationalPartner = $operationalPartner;

        return $this;
    }

    /**
     * @return Collection<int, Access>
     */
    public function getFinanciers(): Collection
    {
        return $this->financiers;
    }

    public function addFinancier(Access $financier): self
    {
        if (!$this->financiers->contains($financier)) {
            $this->financiers[] = $financier;
        }

        return $this;
    }

    public function removeFinancier(Access $financier): self
    {
        $this->financiers->removeElement($financier);

        return $this;
    }

    /**
     * @return Collection<int, File>
     */
    public function getFiles(): Collection
    {
        return $this->files;
    }

    public function addFile(File $file): self
    {
        if (!$this->files->contains($file)) {
            $this->files[] = $file;
        }

        return $this;
    }

    public function removeFile(File $file): self
    {
        $this->files->removeElement($file);

        return $this;
    }

    /**
     * @return Collection<int, EducationalProjectIntangible>
     */
    public function getEducationalProjectIntangibles(): Collection
    {
        return $this->educationalProjectIntangibles;
    }

    public function addEducationalProjectIntangible(EducationalProjectIntangible $educationalProjectIntangible): self
    {
        if (!$this->educationalProjectIntangibles->contains($educationalProjectIntangible)) {
            $this->educationalProjectIntangibles[] = $educationalProjectIntangible;
            $educationalProjectIntangible->setEducationalProject($this);
        }

        return $this;
    }

    public function removeEducationalProjectIntangible(EducationalProjectIntangible $educationalProjectIntangible): self
    {
        if ($this->educationalProjectIntangibles->removeElement($educationalProjectIntangible)) {
            // set the owning side to null (unless already changed)
            if ($educationalProjectIntangible->getEducationalProject() === $this) {
                $educationalProjectIntangible->setEducationalProject(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, EducationalProjectPayer>
     */
    public function getBillingReceivers(): Collection
    {
        return $this->billingReceivers;
    }

    public function addBillingReceiver(EducationalProjectPayer $billingReceiver): self
    {
        if (!$this->billingReceivers->contains($billingReceiver)) {
            $this->billingReceivers[] = $billingReceiver;
            $billingReceiver->setEducationalProjectReceiver($this);
        }

        return $this;
    }

    public function removeBillingReceiver(EducationalProjectPayer $billingReceiver): self
    {
        if ($this->billingReceivers->removeElement($billingReceiver)) {
            // set the owning side to null (unless already changed)
            if ($billingReceiver->getEducationalProjectReceiver() === $this) {
                $billingReceiver->setEducationalProjectReceiver(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, BillLine>
     */
    public function getBillLines(): Collection
    {
        return $this->billLines;
    }

    public function addBillLine(BillLine $billLine): self
    {
        if (!$this->billLines->contains($billLine)) {
            $this->billLines[] = $billLine;
            $billLine->setEducationalProject($this);
        }

        return $this;
    }

    public function removeBillLine(BillLine $billLine): self
    {
        if ($this->billLines->removeElement($billLine)) {
            // set the owning side to null (unless already changed)
            if ($billLine->getEducationalProject() === $this) {
                $billLine->setEducationalProject(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, AttendanceBooking>
     */
    public function getAttendanceBooking(): Collection
    {
        return $this->attendanceBooking;
    }

    public function addAttendanceBooking(AttendanceBooking $attendanceBooking): self
    {
        if (!$this->attendanceBooking->contains($attendanceBooking)) {
            $this->attendanceBooking[] = $attendanceBooking;
            $attendanceBooking->setEducationalProject($this);
        }

        return $this;
    }

    public function removeAttendanceBooking(AttendanceBooking $attendanceBooking): self
    {
        if ($this->attendanceBooking->removeElement($attendanceBooking)) {
            // set the owning side to null (unless already changed)
            if ($attendanceBooking->getEducationalProject() === $this) {
                $attendanceBooking->setEducationalProject(null);
            }
        }

        return $this;
    }

    public function getPlace(): ?Place
    {
        return $this->place;
    }

    public function setPlace(?Place $place): self
    {
        $this->place = $place;

        return $this;
    }

    public function getRoom(): ?Room
    {
        return $this->room;
    }

    public function setRoom(?Room $room): self
    {
        $this->room = $room;

        return $this;
    }

    /**
     * @return Collection<int, Access>
     */
    public function getOrganizer(): Collection
    {
        return $this->organizer;
    }

    public function addOrganizer(Access $organizer): self
    {
        if (!$this->organizer->contains($organizer)) {
            $this->organizer[] = $organizer;
        }

        return $this;
    }

    public function removeOrganizer(Access $organizer): self
    {
        $this->organizer->removeElement($organizer);

        return $this;
    }

    public function getAgeDistribution(): ?EducationalProjectAge
    {
        return $this->ageDistribution;
    }

    public function setAgeDistribution(?EducationalProjectAge $ageDistribution): self
    {
        $this->ageDistribution = $ageDistribution;

        return $this;
    }
}
